#include <cmath>
#include <iostream>
using namespace std;

#include "edo.hpp"

void timeloop(ODE * po, double Tf, double dt){
    double times =0.0;
    while (times < Tf){
        po->solve_dt(0.1);
        times = times +dt;
        cout<<" "<<(*po)[0]<<endl;
   }
}


void ODE::set_flow( valarray<double> (*p)(valarray<double> a)){
    flow = p;
}
double ODE::operator [](int i){
    return (Xn.back())[i];
}

valarray<double> ODE::compute_flux(valarray <double> x){
    valarray<double> y(n);
    y = flow(x);
    return y;

}

void ODE::solve_dt(double dt){
    valarray<double> y(n);
    y = compute_flux(Xn.back());
    Xn.push_back(Xn.back()+dt*y);

} // justifier l'avanatge de val array ici, par rapport a vecteur pour la solution courante au temps
// utiliser au possible les outils de vecteur


valarray<double> Poisson_system::compute_flux(valarray<double> x){
    valarray <double> y(n), z(n);
    y = GradH(x);
    z = Jx(x,y);
    return z;
}

void Poisson_system::set_H( double (*p)(valarray<double> a)){
    Ham = p;
}
void Poisson_system::set_dH( valarray<double> (*p)(valarray<double> a)){
    GradH = p;
}
void Poisson_system::set_Jx( valarray<double> (*p)(valarray<double> a, valarray<double> b)){
    Jx = p;
}



