#include <iostream>

#include "edo.hpp"


valarray<double> expt_f(valarray<double> x){
   valarray<double> y(1);
   y = -x;
   return y;
}

double HLV(valarray<double> x){
   double res=-x[0]+log(x[0])-(4.0/3.0)*x[1]+(2.0/3.0)*log(x[1]);
   return res;
}

valarray<double> JxLV(valarray<double> x,valarray<double> dh){
   valarray<double> y(2);
   y[0] = -x[0]*x[1]*dh[1];
   y[1] =x[0]*x[1]*dh[0];
   return y;
}

valarray<double> dHLV(valarray<double> x){
   valarray<double> y(2);
   y[0] = -1.0 + 1.0/x[0];
   y[1] =- (4.0/3.0) + (2.0/3.0)/x[1];
   return y;
}

double H_ParLin2(valarray<double> x){
   double w=0.5, m=2.0;
   double res= 0.5*(x[2]*x[2]+x[3]*x[3])/m +0.5*w*(x[0]*x[0]+x[1]*x[1]);
   return res;
}

valarray<double> dH_ParLin2(valarray<double> x){
   valarray<double> y(4);
   double w=0.5, m=2.0;
   y[0]= w*x[0];
   y[1]= w*x[1];
   y[2]= x[2]/m;
   y[3]= x[3]/m; 
   return y;
}

int main() {

   ODE * p;
   valarray<double> x0(2.0,1);
   ODE expt(1,x0);
   expt.set_flow(expt_f);
   p = &expt;
   timeloop(p,1.0,0.1);

   cout<<"coucou 1"<<endl;

   double t[] = {0.45,0.55};
   valarray<double> LV0(t,2);
   Poisson_system Lv(2,LV0);
   Lv.set_H(HLV);
   Lv.set_dH(dHLV);
   Lv.set_Jx(JxLV);
   p = &Lv;
   timeloop(p,1.0,0.1);

   double t2[] = {0.1,0.7,0.0,0.0};
   valarray<double> H0(t2,4);
   Hamiltonian_system<2> Oscillator_two(H0);
   Oscillator_two.set_H(H_ParLin2);
   Oscillator_two.set_dH(dH_ParLin2);

   p = &Oscillator_two;
   timeloop(p,1.0,0.1);
 
   cout<<"coucou 3"<<endl;

   return 0;
}
